//#include <fstream>

#include <vector>

#include "VecSymSolver.h"
#include "DOFMatrix.h"
#include "DiagonalPreconditioner.h"
#include "ILUPreconditioner.h"
#include "MatVecMultiplier.h"

namespace AMDiS {

  template<typename VectorType>
  VecSymSolver<VectorType>::VecSymSolver(std::string name) 
    : OEMSolver<VectorType>(name) 
  {}

  template<typename VectorType>
  VecSymSolver<VectorType>::~VecSymSolver() {}

/*  template<typename VectorType>
  int VecSymSolver<VectorType>::solveSystem(MatVecMultiplier<VectorType> *matVec,
					    VectorType *x, VectorType *b)
  {
    FUNCNAME("VecSymSolver::solveSystem()");

    StandardMatVec<Matrix<DOFMatrix*>, SystemVector> *stdMatVec = 
      dynamic_cast<StandardMatVec<Matrix<DOFMatrix*>, SystemVector> *>(matVec);

    Matrix<DOFMatrix*> *m = stdMatVec->getMatrix();

    DOFMatrix* dofm = (*m)[0][0];    

    int nComponents = m->getSize();
    int oneMatrixSize = dofm->getFESpace()->getAdmin()->getUsedSize();
    int bigMatrixSize = oneMatrixSize;

    std::vector< std::vector< MatEntry33 > > newm;
    newm.resize(bigMatrixSize);

    std::vector<V3> xvec(bigMatrixSize);
    std::vector<V3> bvec(bigMatrixSize);
    for (int i = 0; i < bigMatrixSize; i++) {
      xvec[i].resize(3);
      bvec[i].resize(3);
    }

    for (int stencilRow = 0; stencilRow < nComponents; stencilRow++) {
      for (int stencilCol = 0; stencilCol < nComponents; stencilCol++) {

	if (!(*m)[stencilRow][stencilCol]) {
//	  std::cout << "Matrix " << stencilRow << "-" << stencilCol << " ist 0!" << std::endl;
	  continue;
	} else {
	  (*m)[stencilRow][stencilCol]->print();

	    if ((*m)[stencilRow][stencilCol]->symmetric()) {
		std::cout << "Matrix " << stencilRow << "-" << stencilCol << " ist symmetrisch!" << std::endl;
	    } else {
		std::cout << "Matrix " << stencilRow << "-" << stencilCol << " ist nicht symmetrisch!" << std::endl;
	    }
	};

	DOFMatrix::Iterator matrixRow((*m)[stencilRow][stencilCol], USED_DOFS);
 	int rowIndex = 0;
 	for (matrixRow.reset(); !matrixRow.end(); ++matrixRow, rowIndex++) {
 	  for (int i = 0; i < static_cast<int>((*matrixRow).size()); i++) {	    
 	    if ((*matrixRow)[i].col >= 0) {			      
	      MatEntry33 *newMe = NULL;

// 	      if ((stencilRow == 0) && (stencilCol == 0) && 
// 		  (rowIndex == 0) && ((*matrixRow)[i].col == 0)) {
// 		std::cout << "Dich habe ich: " << (*matrixRow)[i].entry << std::endl;
// 	      }
	      
	      for (int j = 0; j < static_cast<int>(newm[rowIndex].size()); j++) {
		if (newm[rowIndex][j].col == (*matrixRow)[i].col) {
		  newMe = &(newm[rowIndex][j]);
		}
	      }

	      if (newMe == NULL) {
// 		if ((rowIndex == 0) && ((*matrixRow)[i].col == 0)) {
// 		  std::cout << "0-Matrix neu anlegen!" << std::endl;
// 		};

		MatEntry33 newMe;
		newMe.col = (*matrixRow)[i].col;
		newMe.entry.set(stencilRow, stencilCol, (*matrixRow)[i].entry);
		newm[rowIndex].push_back(newMe);

// 		if ((rowIndex == 0) && ((*matrixRow)[i].col == 0)) {
// 		    std::cout << "0-Matrix: " << std::endl;
// 		    newMe.entry.print();
// 		}

	      } else {
		newMe->entry.set(stencilRow, stencilCol, (*matrixRow)[i].entry);

// 		if ((rowIndex == 0) && ((*matrixRow)[i].col == 0)) {
// 		    std::cout << "0-Matrix: " << std::endl;
// 		    newMe->entry.print();
// 		}
	      }

 	    }
 	  }
 	}

      }
    }


    for (int i = 0; i < static_cast<int>(newm.size()); i++) {
      
      for (int j = 0; j < static_cast<int>(newm[j].size()); j++) {
	if (newm[i][j].col == i) {
	  MatEntry33 tmp = newm[i][0];
	  newm[i][0] = newm[i][j];
	  newm[i][j] = tmp;

	  break;
	}
      }
    }


    std::cout << "Gesuchter Vektor ist: " << std::endl;

    for (int i = 0; i < x->getSize(); i++) {
      DOFVector<double>::Iterator it(x->getDOFVector(i), USED_DOFS);

      int counter = 0;
      for (it.reset(); !it.end(); it++, counter++) {
	std::cout << (*it) << std::endl;

	xvec[counter][i] = *it;
      }
    }

    std::cout << "Rechte Seite ist: " << std::endl;

    for (int i = 0; i < b->getSize(); i++) {
      DOFVector<double>::Iterator it(b->getDOFVector(i), USED_DOFS);

      int counter = 0;
      for (it.reset(); !it.end(); it++, counter++) {
	std::cout << (*it) << std::endl;

	bvec[counter][i] = *it;
      }
    }


    bool isSym = true;

    for (int i = 0; i < static_cast<int>(newm.size()); i++) {

//      std::cout << "Zeile " << i << ": " << std::endl;

      for (int j = 0; j < static_cast<int>(newm[i].size()); j++) {
	int col = newm[i][j].col;

// 	std::cout << col << ": [ ";
// 	for (int k = 0; k < 9; k++) {
// 	  std::cout << newm[i][j].entry[k] << " ";
// 	}
// 	std::cout << "], ";

	if (col != i) {
	  for (int k = 0; k < static_cast<int>(newm[col].size()); k++) {
	    if (newm[col][k].col == i) {
	      if (newm[i][j].entry != newm[col][k].entry) {
		isSym = false;
	      }
	    }
	  }
	}
      }

//      std::cout << std::endl;
    }

    if (isSym) {
      std::cout << "Gesamtmatrix ist symmetrisch!" << std::endl;
    } else {
      std::cout << "Gesamtmatrix ist nicht symmetrisch!" << std::endl;      
    }

    CGSolver< std::vector<V3> > solver2(this->name);
    solver2.initParameters();
    solver2.setVectorCreator(NEW V3Creator(bigMatrixSize));

    StandardMatVec< std::vector< std::vector<MatEntry33> >, std::vector<V3> > mv(&newm);

    *p = *x;
    *p *= -1.0;
    matVec->matVec(NoTranspose, *p, *r);
    *r += *b;

    std::cout << "Checking res 1: " << norm(r) << std::endl;

    solver2.solve(&mv, &xvec, &bvec);

    for (int i = 0; i < x->getSize(); i++) {
      DOFVector<double>::Iterator it(x->getDOFVector(i), USED_DOFS);

      int counter = 0;
      for (it.reset(); !it.end(); it++, counter++) {
	  *it = xvec[counter][i];
      }
    }

    *p = *x;
    *p *= -1.0;
    matVec->matVec(NoTranspose, *p, *r);
    *r += *b;

    std::cout << "Checking res 2: " << norm(r) << std::endl;
    
    ERROR_EXIT("na, dass wars wohl!\n");

    return(0);
  }
*/


    template<typename VectorType>
  int VecSymSolver<VectorType>::solveSystem(MatVecMultiplier<VectorType> *matVec,
					    VectorType *x, VectorType *b)
  {
    FUNCNAME("VecSymSolver::solveSystem()");

    StandardMatVec<Matrix<DOFMatrix*>, SystemVector> *stdMatVec = 
      dynamic_cast<StandardMatVec<Matrix<DOFMatrix*>, SystemVector> *>(matVec);

    Matrix<DOFMatrix*> *m = stdMatVec->getMatrix();

    DOFMatrix* dofm = (*m)[0][0];    

    int nComponents = m->getSize();
    int oneMatrixSize = dofm->getFESpace()->getAdmin()->getUsedSize();
    int bigMatrixSize = oneMatrixSize * nComponents;

    std::vector< std::vector< MatEntry > > newm(bigMatrixSize, std::vector<MatEntry>(0));
    std::vector<double> xvec(bigMatrixSize);
    std::vector<double> bvec(bigMatrixSize);

    int nElements = 0;

    for (int stencilRow = 0; stencilRow < nComponents; stencilRow++) {
      for (int stencilCol = 0; stencilCol < nComponents; stencilCol++) {

	if (!(*m)[stencilRow][stencilCol]) {
	  continue;
	}
	
	//	std::cout << "------------------------------" << std::endl;
	//	std::cout << "Matrix " << stencilRow << " - " << stencilCol << std::endl;
	
	//	(*m)[stencilRow][stencilCol]->print();

	DOFMatrix::Iterator matrixRow((*m)[stencilRow][stencilCol], USED_DOFS);
 	int rowIndex = 0;
 	for (matrixRow.reset(); !matrixRow.end(); matrixRow++, rowIndex++) {
 	  for (int i = 0; i < static_cast<int>((*matrixRow).size()); i++) {	      
 	    if ((*matrixRow)[i].col >= 0) {
 	      MatEntry newMe;
	      newMe.entry = (*matrixRow)[i].entry;
	      newMe.col = ((*matrixRow)[i].col * nComponents) + stencilCol;

	      newm[(rowIndex  * nComponents) + stencilRow].push_back(newMe);
      
	      nElements++;
 	    }
 	  }
 	}

// 	if ((*m)[stencilRow][stencilCol]->symmetric()) {  
// 	    std::cout << "Matrix " << stencilRow << "-" << stencilCol << " ist symmetrisch!" << std::endl;
// 	} else {
// 	    std::cout << "Matrix " << stencilRow << "-" << stencilCol << " ist nicht symmetrisch!" << std::endl;
// 	}	


      }
    }


    for (int i = 0; i < static_cast<int>(newm.size()); i++) {      
      for (int j = 0; j < static_cast<int>(newm[i].size()); j++) {
 	if (newm[i][j].col == i) {
 	  MatEntry tmp = newm[i][0];
 	  newm[i][0] = newm[i][j];
 	  newm[i][j] = tmp;

 	  break;
 	}
      }     
    }

//     std::cout << "-------------------------------" << std::endl;
//     for (int i = 0; i < static_cast<int>(newm.size()); i++) {      
//       std::cout << "row : " << i << std::endl;
//       for (int j = 0; j < static_cast<int>(newm[i].size()); j++) {
// 	std::cout << " ( " << newm[i][j].col << ", " << newm[i][j].entry << ")";
//       }
//       std::cout << std::endl;
//     }

    for (int i = 0; i < x->getSize(); i++) {
      DOFVector<double>::Iterator it(x->getDOFVector(i), USED_DOFS);

      int counter = 0;
      for (it.reset(); !it.end(); it++, counter++) {
	xvec[counter * nComponents + i] = *it;
      }
    }

    for (int i = 0; i < b->getSize(); i++) {
      DOFVector<double>::Iterator it(b->getDOFVector(i), USED_DOFS);

      int counter = 0;
      for (it.reset(); !it.end(); it++, counter++) {
	bvec[counter * nComponents + i] = *it;
      }
    }

    /* ======= CHOLMOD =========
    std::fstream file;

    file.open("matrix.m", fstream::out);
    file << newm.size() << " " << newm.size() << " " << nElements << std::endl;
    for (int i = 0; i < static_cast<int>(newm.size()); i++) {      
      for (int j = 0; j < static_cast<int>(newm[i].size()); j++) {
	file << i + 1 << " " << newm[i][j].col + 1 << " " << newm[i][j].entry << std::endl;
      }
    }
    file.close();

    file.open("vector.m", fstream::out);
    file << bvec.size() << " 1" << std::endl;
    for (int i = 0; i < static_cast<int>(bvec.size()); i++) {
      file << bvec[i] << std::endl;
    }
    file.close();
    */

    bool isSym = true;

    for (int i = 0; i < static_cast<int>(newm.size()); i++) {
      for (int j = 0; j < static_cast<int>(newm[i].size()); j++) {
	int col = newm[i][j].col;

	if (col != i) {
	  for (int k = 0; k < static_cast<int>(newm[col].size()); k++) {
	    if (newm[col][k].col == i) {
	      if (newm[i][j].entry != newm[col][k].entry) {
		isSym = false;
	      }
	    }
	  }
	}
      }
    }

    if (isSym) {
       std::cout << "Matrix is symmetrisch!" << std::endl;
     } else {
       std::cout << "Matrix ist nicht symmetrisch!" << std::endl;
     }



    /* ======= CHOLMOD =========

    double one [2] = {1,0}, m1 [2] = {-1,0};
    cholmod_sparse *A;
    cholmod_dense *ch_b;
    cholmod_dense *ch_x;
    cholmod_dense *ch_r;
    cholmod_common c;
    cholmod_factor *L;
    cholmod_start(&c);

    FILE *f = fopen("matrix.m", "r");
    A = cholmod_read_sparse(f, &c);
    fclose(f);

    f = fopen("vector.m", "r");
    ch_b = cholmod_read_dense(f, &c);
    fclose(f);

    L = cholmod_analyze(A, &c);
    cholmod_factorize(A, L, &c);    

    ch_x = cholmod_solve(CHOLMOD_A, L, ch_b, &c);
    ch_r = cholmod_copy_dense(ch_b, &c);
    cholmod_sdmult (A, 0, m1, one, ch_x, ch_r, &c) ;	   
    std::cout << "NORM: " <<  cholmod_norm_dense(ch_r, 2, &c) << std::endl;

    cholmod_finish(&c);
    */

    //GMResSolver2< std::vector<double> > solver2(this->name);
    //CGSolver< std::vector<double> > solver2(this->name);
    //    BiCGStab< std::vector<double> > solver2(this->name);

    //    solver2.initParameters();
    //    solver2.setVectorCreator(NEW StlVectorCreator(bigMatrixSize));

    //    StandardMatVec< std::vector< std::vector<MatEntry> >, std::vector<double> > mv(&newm);

    //    ILUPreconditionerStd ilu;
    //    ilu.setMatrix(&newm);

    //    DiagonalPreconditionerStd diag;
    //    diag.setMatrix(&newm);

    //    solver2.solve(&mv, &xvec, &bvec, &diag);

     for (int i = 0; i < x->getSize(); i++) {
       DOFVector<double>::Iterator it(x->getDOFVector(i), USED_DOFS);

       int counter = 0;
       for (it.reset(); !it.end(); it++, counter++) {
 	*it = xvec[counter * nComponents + i];
       }
     }

    *p = *x;
    *p *= -1.0;
    matVec->matVec(NoTranspose, *p, *r);
    *r += *b;

	 std::cout << "NORM: " << norm(r) << std::endl;

	 //    ERROR_EXIT("DA\n");

    return(1);
  }
  
}
